LMS/Models/Book.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace LMS.Models
{
    public class Book
    {
        public int BookID { get; set; }
        public string Name { get; set; }
        public string Faculty { get; set; }
        public string Status { get; set; }
        public string Author { get; set; }
        public DateTime PublishedDate { get; set; }
        public DateTime CreatedTS { get; set; }
        public int CreatedBy { get; set; }
        public DateTime ModifiedTS { get; set; }
        public int ModifiedBy { get; set; }

    }
}

LMS/Models/ErrorViewModel.cs
using System;

namespace LMS.Models
{
    public class ErrorViewModel
    {
        public string RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

LMS/Controllers/BookController.cs
using LMS.Data;
using LMS.Models;
using LMS.Repository;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace LMS.Controllers
{
    public class BookController : Controller
    {
      
        private readonly IRepository bookrepo;

        public IActionResult Index()
        {
            IEnumerable<Book> books = bookrepo.GetAllBooks();
            return View(books);
        }

        public BookController(IRepository bookrepo)
        {
            this.bookrepo = bookrepo;
        }
        public IActionResult Create()
        {
            Book book = new Book();
            return View(book);
        }

        [HttpPost]
        public IActionResult Create(Book book)
        {
            try
            {
                book = bookrepo.Insert(book);
            }
            catch (Exception)
            {
                throw;
            }
            return RedirectToAction(nameof(Index));
        }




        
        public IActionResult Details(int id)
        {
            Book book = bookrepo.GetBook(id);
            return View(book);
        }





        public IActionResult Edit(int id)
        {
            Book book = bookrepo.GetBook(id);
            return View(book);
        }
        [HttpPost]
        public IActionResult Edit(Book book)
        {
            try
            {
                book = bookrepo.Update(book);
            }
            catch (Exception)
            {
                throw;
            }
            return RedirectToAction(nameof(Index));
        }






        public IActionResult Delete (int id)
        {
            Book book = bookrepo.GetBook(id);
            return View(book);
        }
        [HttpPost]
        public IActionResult Delete(Book book)
        {
            try
            {
                book = bookrepo.Delete(book);
            }
            catch (Exception)
            {
                throw;
            }
            return RedirectToAction(nameof(Index));
        }






      
    }
}

LMS/Controllers/HomeController.cs
using LMS.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;

namespace LMS.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;

        public HomeController(ILogger<HomeController> logger)
        {
            _logger = logger;
        }

        public IActionResult Index()
        {
            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

LMS/Views/Book/Create.cshtml
@model LMS.Models.Book

@{
    ViewData["Title"] = "Create";
}



<h4>Create Book</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Create">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label asp-for="Name" class="control-label"></label>
                <input asp-for="Name" class="form-control" />
                <span asp-validation-for="Name" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Faculty" class="control-label"></label>
                <input asp-for="Faculty" class="form-control" />
                <span asp-validation-for="Faculty" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Status" class="control-label"></label>
                <input asp-for="Status" class="form-control" />
                <span asp-validation-for="Status" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Author" class="control-label"></label>
                <input asp-for="Author" class="form-control" />
                <span asp-validation-for="Author" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="PublishedDate" class="control-label"></label>
                <input asp-for="PublishedDate" class="form-control" />
                <span asp-validation-for="PublishedDate" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="CreatedTS" class="control-label"></label>
                <input asp-for="CreatedTS" class="form-control" />
                <span asp-validation-for="CreatedTS" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="CreatedBy" class="control-label"></label>
                <input asp-for="CreatedBy" class="form-control" />
                <span asp-validation-for="CreatedBy" class="text-danger"></span>
            </div>
            
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

LMS/Views/Book/Delete.cshtml
@model LMS.Models.Book

@{
    ViewData["Title"] = "Delete";
}

<h1>Delete</h1>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>Book</h4>
    <hr />
    <dl class="row">
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Name)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Name)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Faculty)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Faculty)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Status)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Status)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Author)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Author)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.PublishedDate)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.PublishedDate)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.CreatedTS)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.CreatedTS)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.CreatedBy)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.CreatedBy)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.ModifiedTS)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.ModifiedTS)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.ModifiedBy)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.ModifiedBy)
        </dd>
    </dl>
    
    <form asp-action="Delete">
        <input type="hidden" asp-for="BookID" />
        <input type="submit" value="Delete" class="btn btn-danger" /> |
        <a asp-action="Index">Back to List</a>
    </form>
</div>

LMS/Views/Book/Details.cshtml
@model LMS.Models.Book

@{
    ViewData["Title"] = "Details";
}

<h1>Details</h1>

<div>
    <h4>Book</h4>
    <hr />
    <dl class="row">
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Name)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Name)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Faculty)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Faculty)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Status)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Status)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.Author)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.Author)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.PublishedDate)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.PublishedDate)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.CreatedTS)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.CreatedTS)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.CreatedBy)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.CreatedBy)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.ModifiedTS)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.ModifiedTS)
        </dd>
        <dt class = "col-sm-2">
            @Html.DisplayNameFor(model => model.ModifiedBy)
        </dt>
        <dd class = "col-sm-10">
            @Html.DisplayFor(model => model.ModifiedBy)
        </dd>
    </dl>
</div>
<div>
    <a asp-action="Edit" asp-route-id="@Model.BookID">Edit</a> |
    <a asp-action="Index">Back to List</a>
</div>

LMS/Views/Book/Edit.cshtml
@model LMS.Models.Book

@{
    ViewData["Title"] = "Edit";
}

<h1>Edit</h1>

<h4>Book</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Edit">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <input type="hidden" asp-for="BookID" />
            <div class="form-group">
                <label asp-for="Name" class="control-label"></label>
                <input asp-for="Name" class="form-control" />
                <span asp-validation-for="Name" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Faculty" class="control-label"></label>
                <input asp-for="Faculty" class="form-control" />
                <span asp-validation-for="Faculty" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Status" class="control-label"></label>
                <input asp-for="Status" class="form-control" />
                <span asp-validation-for="Status" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Author" class="control-label"></label>
                <input asp-for="Author" class="form-control" />
                <span asp-validation-for="Author" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="PublishedDate" class="control-label"></label>
                <input asp-for="PublishedDate" class="form-control" />
                <span asp-validation-for="PublishedDate" class="text-danger"></span>
            </div>
            
            <div class="form-group">
                <label asp-for="ModifiedTS" class="control-label"></label>
                <input asp-for="ModifiedTS" class="form-control" />
                <span asp-validation-for="ModifiedTS" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="ModifiedBy" class="control-label"></label>
                <input asp-for="ModifiedBy" class="form-control" />
                <span asp-validation-for="ModifiedBy" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Save" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

LMS/Views/Book/Index.cshtml
@model IEnumerable<LMS.Models.Book>

@{
    ViewData["Title"] = "Index";
}

<h1>Index</h1>

<p>
    <a asp-action="Create">Create New</a>
</p>
<table class="table">
    <thead>
        <tr>
            <th>
                BookID
            </th>
            <th>
                Name
            </th>
            <th>
                Faculty
            </th>
            <th>
                Status
            </th>
            <th>
                Author
            </th>
            <th>
                PublishedDate
            </th>
            <th>
                CreatedTS
            </th>
            <th>
                CreatedBy
            </th>
            <th>
                ModifiedTS
            </th>
            <th>
                ModifiedBy
            </th>

            <th></th>
        </tr>
    </thead>
    <tbody>
@foreach (var item in Model) {
        <tr>
            <td>
                @Html.DisplayFor(modelItem => item.BookID)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Name)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Faculty)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Status)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.Author)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.PublishedDate)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.CreatedTS)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.CreatedBy)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.ModifiedTS)
            </td>
            <td>
                @Html.DisplayFor(modelItem => item.ModifiedBy)
            </td>

            <td>
                <a asp-action="Edit" class="text-danger" asp-route-id="@item.BookID">Edit</a> |
                <a asp-action="Details" asp-route-id="@item.BookID">Details</a> |
                <a asp-action="Delete" asp-route-id="@item.BookID">Delete</a>
            </td>
        </tr>
}
    </tbody>
</table>

LMS/Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<div class="text-center">
    <h1 class="display-4">Welcome</h1>
    <p>Learn about <a href="https://docs.microsoft.com/aspnet/core">building Web apps with ASP.NET Core</a>.</p>
</div>

LMS/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - LMS</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">LMS</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex flex-sm-row-reverse">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Book" asp-action="Index">Books</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2022 - LMS - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>